# -*- coding: UTF-8 -*-
import re
import json


def get_tags():
    return ['3', '3.3']


def run_task(runcontext):
    ansible_params = runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params, "chdir", None)
    runcontext.set_mod_params_instance(ansible_params, "executable", None)

    module = runcontext.get_module_file("shell.py")
    rc, out = run_audit(runcontext, ansible_params, module)
    return rc, out


def run_audit(runcontext, ansible_params, module):
    curtemplate = runcontext.get_template()
    ret_code = -1
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"

    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = r'''egrep "cron\.\*" /etc/rsyslog.conf 2>/dev/null | grep "/var/log/cron" | grep -v '^[[:space:]]*#' '''
    tmp_vars["systemvalue1"] = ""

    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = r'''unset cron_1 cron_2 cron_3;if [ -s /etc/syslog-ng/syslog-ng.conf ];then cron_1=`grep -v "^[[:space:]]*#" /etc/syslog-ng/syslog-ng.conf | egrep "filter[[:space:]]*.*[[:space:]]*[[:space:]]*facility\(cron\);[[:space:]]*.*;" | wc -l`;if [ $cron_1 -ge 1 ];then cron_2=`grep -v "^[[:space:]]*#" /etc/syslog-ng/syslog-ng.conf | egrep "destination[[:space:]]*cron.*[[:space:]]*[[:space:]]*file\(.*/var/log/cron.*\)[[:space:]]*;[[:space:]]*.*;"|awk '{print $2}'`;file=`grep -v "^[[:space:]]*#" /etc/syslog-ng/syslog-ng.conf | grep "destination\s*cron" | grep -E "file\((\"|').+(\"|')\)" | sed "s/'/\"/g" | awk -F '"' '{print $2}'`;if [ -n "$cron_2" -a -f "$file" ];then cron_3=`grep -v "^[[:space:]]*#" /etc/syslog-ng/syslog-ng.conf | egrep "log[[:space:]]*.*[[:space:]]*source\(src\);[[:space:]]*filter\(.*\);[[:space:]]*destination\($cron_2\);[[:space:]]*.*;" | wc -l`;if [ $cron_3 -ge 1 ];then echo "Cron log has been configured";fi;else echo "$file does not exist";fi;fi;fi;unset cron_1 cron_2 cron_3; '''
    tmp_vars["systemvalue2"] = ""

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand1"])
    arc1, astdout1, astderr1 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc1, astdout1, astderr1)
    runcontext.sleep()

    runcontext.set_mod_params_instance(ansible_params, "command", tmp_vars["scancommand2"])
    arc2, astdout2, astderr2 = runcontext.invoke_module(module, ansible_params)
    runcontext.log_debug_invoke_result(arc2, astdout2, astderr2)
    runcontext.sleep()

    if arc1 != 0:
        return (-2, "Failed to invoke module: %s." % astdout1)
    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]
    match1 = re.match(r".+", astdout1)
    tmp_vars["systemvalue1"] = astdout1
    if match1:
        tmp_vars["checkresult1"] = "pass"

    if arc2 != 0:
        return (-2, "Failed to invoke module: %s." % astdout2)
    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]
    match2 = re.match(r"Cron log has been configured", astdout2)
    tmp_vars["systemvalue2"] = astdout2
    if match2:
        tmp_vars["checkresult2"] = "pass"

    if tmp_vars["checkresult1"] == "pass" or tmp_vars["checkresult2"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"] = "pass"

    rc, out = curtemplate.render(runcontext.get_template_file('t_3_3.j2'), **tmp_vars)

    if rc == False:
        return (-2, "Failed to render template.%s" % out)

    return ret_code, out
